define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for EstadoActualOrdenes generated by Appery.io
         * @module EstadoActualOrdenes
         */
        APP.controller('EstadoActualOrdenes', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.orders = Apperyio.EntityAPI('Ordenes');
            /**
             * User controller functions
             */
            /**
             * @function init
             * @param fechaAsignacion
             */
            $scope.init = function(fechaAsignacion) {
                //On load screen logic
                $scope.orders = [];
                $scope.ordenesTotal = 0;
                $scope.markers = [];
                $scope.fechaAsignacionData = fechaAsignacion ? formatDate3(fechaAsignacion.toISOString()) : formatDateNow2(0);
                $scope.datosEmpresa = JSON.parse(localStorage.getItem("companyData"));
                $scope.estadoOp = JSON.parse(localStorage.getItem("diasOperacion"));
                $scope.mOperators = localStorage.getItem("arrayOperators") ? JSON.parse(localStorage.getItem("arrayOperators")) : [];
                $scope.mapCtrl = {
                    latitude: -33.502113,
                    longitude: -70.693409,
                    zoom: 10
                };
                var contadorEstados = {
                    "2": 0,
                    "4": 0,
                    "5": 0,
                    "6": 0
                };
                var tecnicos = {
                    "2": {},
                    "4": {},
                    "5": {},
                    "6": {}
                };
                for (var i in tecnicos) {
                    for (var j in $scope.mOperators) {
                        tecnicos[i][$scope.mOperators[j].codigo] = 0;
                    }
                }
                var tecnicosNames = [];
                for (var j in $scope.mOperators) {
                    tecnicosNames.push($scope.mOperators[j].nombre);
                }
                //Cargar Ordenes
                var requestData = {};
                requestData = (function mapping9044($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [{
                                "companyId": $scope.datosEmpresa.idCliente
                            },
                            ($scope.fechaAsignacionModel) ? {
                                "assignmentDate": formatDate3($scope.fechaAsignacionModel.toISOString())
                            } : {
                                "assignmentDate": formatDateNow2(0)
                            },
                            {
                                "documentStatus": {
                                    "$in": [2, 4, 5, 6]
                                }
                            },
                        ]
                    };
                    requestData.params.limit = 300;
                    requestData.params.sort = "operatorCode, documentStatus";
                    return requestData;
                    /*CLICK TO EDIT MAPPING*/
                })($scope);
                $scope.showLoading();
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_query_service")(requestData).then(
                    function(success) { // success callback
                        (function mapping1294(success, $scope) {
                            var orders_scope = $scope.orders;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(orders_scope, '[' + i + '].codigo', success.data[i].documentCode);
                                _.set(orders_scope, '[' + i + '].ingeniero', success.data[i].operatorCode);
                                _.set(orders_scope, '[' + i + '].estado', success.data[i].documentStatus);
                                _.set(orders_scope, '[' + i + '].color', $scope.stateList[success.data[i].documentStatus].color);
                                _.set(orders_scope, '[' + i + '].estadoTexto', $scope.stateList[success.data[i].documentStatus].estado);
                                _.set(orders_scope, '[' + i + '].tipoServicio', success.data[i].formType);
                                _.set(orders_scope, '[' + i + '].subTipoServicio', success.data[i].formSubType);
                                _.set(orders_scope, '[' + i + '].receiverAntecedent', success.data[i].receiverAntecedent);
                                _.set(orders_scope, '[' + i + '].receiverContact', success.data[i].receiverContact);
                                _.set(orders_scope, '[' + i + '].previousDiagnosis', success.data[i].previousDiagnosis);
                                _.set(orders_scope, '[' + i + '].productAntecedent', success.data[i].productAntecedent);
                                _.set(orders_scope, '[' + i + '].serviceAntecedent', success.data[i].serviceAntecedent);
                                _.set(orders_scope, '[' + i + '].operationData', success.data[i].operationData);
                                /*            var contFotos = 0;
                                for(j=1; j<=10; ++j) {
                                    _.set(orders_scope, '[' + i + '].foto'+j, success.data[i]["foto"+j]);
                                }*/
                                //            _.set(orders_scope, '[' + i + '].evidencias', contFotos);
                                _.set(orders_scope, '[' + i + '].tecnico', nameOperator(success.data[i].operatorCode));
                                if (success.data[i].documentStatus > 3 && success.data[i].operationData.additionalData.statusEndDocument.endCode) {
                                    _.set(orders_scope, '[' + i + '].comentarioCierre', success.data[i].operationData.additionalData.statusEndDocument.endCode + "-" + success.data[i].operationData.additionalData.statusEndDocument.endMessage + (success.data[i].operationData.additionalData.statusEndDocument.addText ? " " + success.data[i].operationData.additionalData.statusEndDocument.addText : ""));
                                } else {
                                    _.set(orders_scope, '[' + i + '].comentarioCierre', "");
                                }
                                _.set(orders_scope, '[' + i + '].mark', success.data[i].assignmentLocation);
                                if (orders_scope[i].mark) {
                                    orders_scope[i].mark.options = $scope.stateList[success.data[i].documentStatus].optionsLocation;
                                }
                                _.set(orders_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(orders_scope, '[' + i + '].color', $scope.stateList[success.data[i].documentStatus].color);
                                _.set(orders_scope, '[' + i + '].colorExistePosGPS', success.data[i].assignmentLocation ? "default" : "danger");
                                _.set(orders_scope, '[' + i + '].msgNoPosGPS', success.data[i].assignmentLocation ? "" : " (POSICION GPS NO DETERMINADA)");
                                contadorEstados[success.data[i].documentStatus]++;
                                tecnicos[success.data[i].documentStatus][success.data[i].operatorCode]++;
                                //Agregamos las columnas dinámicas por cada orden
                                orders_scope[i].columnValues = [];
                                orders_scope[i].columnNames = [];
                                if ($scope.datosEmpresa.config.dataViewActualState) {
                                    for (var j in $scope.datosEmpresa.config.dataViewActualState) {
                                        e = $scope.datosEmpresa.config.dataViewActualState[j];
                                        var a = null;
                                        //alert(operationData.form[0].sectionData.fieldSections[1].fields);
                                        eval("a = orders_scope[" + i + "]." + e.array);
                                        if (a) {
                                            for (var k in a) {
                                                if (e.names.includes(a[k][e.key])) {
                                                    orders_scope[i].columnValues.push(a[k][e.value]);
                                                    orders_scope[i].columnNames.push(a[k][e.key]);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            $scope.orders = orders_scope;
                            /*CLICK TO EDIT MAPPING*/
                        })(success, $scope);
                        $scope.ordenesTotal = $scope.orders.length;
                        var seriesT = [$scope.stateList[2].estado, $scope.stateList[4].estado, $scope.stateList[5].estado, $scope.stateList[6].estado];
                        var colores = [$scope.stateList[2].colorRGB, $scope.stateList[4].colorRGB, $scope.stateList[5].colorRGB, $scope.stateList[6].colorRGB];
                        $scope.polarData = {
                            labels: seriesT,
                            data: [contadorEstados[2], contadorEstados[4], contadorEstados[5], contadorEstados[6]],
                            colours: colores
                        };
                        var labelsT = [];
                        var dataT = [];
                        for (var i in tecnicos) {
                            dataFila = [];
                            for (var j in tecnicos[i]) {
                                dataFila.push(tecnicos[i][j]);
                            }
                            dataT.push(dataFila);
                        }
                        $scope.chartData = {
                            labels: tecnicosNames,
                            series: seriesT,
                            data: dataT,
                            colours: colores
                        };
                        $scope.stopLoading();
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        $scope.mAlert("Hubo errores al cargar la información: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function formatDateNow2
             * @param dias
             */
            function formatDateNow2(dias) {
                var today = new Date();
                today.setDate(today.getDate() + dias);
                var dd = today.getDate();
                var mm = today.getMonth() + 1;
                var yyyy = today.getFullYear();
                return yyyy + '-' + $scope.addZero(mm) + '-' + addZero(dd);
            };
            /**
             * @function formatDate3
             * @param dat
             */
            function formatDate3(dat) {
                var fecha = dat.split("T");
                return fecha[0];
            };
            /**
             * @function nameOperator
             * @param idOperator
             */
            function nameOperator(idOperator) {
                for (var i in $scope.mOperators)
                    if ($scope.mOperators[i].codigo == idOperator)
                        return $scope.mOperators[i].nombre;
                return "";
            };
            /**
             * @function setCenterMap
             * @param mark
             * @param zoom
             */
            $scope.setCenterMap = function(mark, zoom) {
                $scope.mapCtrl = mark;
                $scope.mapCtrl.zoom = zoom ? zoom : 14;
            };
            /**
             * @function descargar
             */
            $scope.descargar = function() {
                tableToExcel('dataTable', 'Ordenes');
            };
        }
    });